Index: include/asterisk/mod_format.h
===================================================================
--- include/asterisk/mod_format.h	(revision 112555)
+++ include/asterisk/mod_format.h	(working copy)
@@ -117,6 +117,7 @@
 	char *buf;		/*!< buffer pointed to by ast_frame; */
 	void *_private;	/*!< pointer to private buffer */
 	const char *orig_chan_name;
+	char *write_buffer;
 };
 
 /*! 
Index: main/file.c
===================================================================
--- main/file.c	(revision 112555)
+++ main/file.c	(working copy)
@@ -817,17 +817,22 @@
 			ast_safe_system(cmd);
 	}
 
+	if(f->fmt->close){
+		f->fmt->close(f);
+	}
 	if (f->filename)
 		ast_free(f->filename);
 	if (f->realfilename)
 		ast_free(f->realfilename);
-	if (f->fmt->close)
-		f->fmt->close(f);
 	fclose(f->f);
 	if (f->vfs)
 		ast_closestream(f->vfs);
 	if (f->orig_chan_name)
 		free((void *) f->orig_chan_name);
+	if (f->write_buffer){
+		ast_free(f->write_buffer);
+	}
+
 	ast_module_unref(f->fmt->module);
 	ast_free(f);
 	return 0;
@@ -1051,6 +1056,11 @@
 			}
 			fs->vfs = NULL;
 			/* If truncated, we'll be at the beginning; if not truncated, then append */
+
+			if ( (fs->write_buffer=(char *)ast_malloc(32768)) ){
+				setvbuf(fs->f,fs->write_buffer,_IOFBF,32768);
+			}
+
 			f->seek(fs, 0, SEEK_END);
 		} else if (errno != EEXIST) {
 			ast_log(LOG_WARNING, "Unable to open file %s: %s\n", fn, strerror(errno));
Index: formats/format_wav.c
===================================================================
--- formats/format_wav.c	(revision 112555)
+++ formats/format_wav.c	(working copy)
@@ -328,6 +328,11 @@
 {
 	char zero = 0;
 	struct wav_desc *fs = (struct wav_desc *)s->_private;
+
+	if(s->filename){
+		update_header(s->f);
+	}
+
 	/* Pad to even length */
 	if (fs->bytes & 0x1)
 		fwrite(&zero, 1, 1, s->f);
@@ -416,7 +421,6 @@
 	}
 
 	s->bytes += f->datalen;
-	update_header(fs->f);
 		
 	return 0;
 
